applications/consolidated_report/urls.py
from django.urls import path

from .views.consolidated_report_view import ConsolidatedReportDetails, ConsolidatedReportList, ConsolidatedReportListJson, ConsolidatedReportPrint, ConsolidatedReportPDF # call the view classes here

app_name = 'consolidated-reports'
urlpatterns = [
    path('details/', ConsolidatedReportDetails.as_view(), name='details'),
    path('datalist/', ConsolidatedReportListJson.as_view(), name='datalist'),
    path('list/', ConsolidatedReportList.as_view(), name='list'),
    path('print-preview/', ConsolidatedReportPrint.as_view(), name='print-preview'),
    path('print/', ConsolidatedReportPDF.as_view(), name='print'),
]

applications/general_report/urls.py
from django.urls import path

from .views.general_report_view import GeneralReportCreate, GeneralReportUpdate # call the view classes here
from .views.start_diagnosis_view import StartDiagnosisCreate, StartDiagnosisUpdate

app_name = "general-reports"
urlpatterns = [
    path('start/', StartDiagnosisCreate.as_view(), name='start-diagnosis'),
    path('update-diagnosis/', StartDiagnosisUpdate.as_view(), name='update-diagnosis'),
    path('create/', GeneralReportCreate.as_view(), name='create'),
    path('update/', GeneralReportUpdate.as_view(), name='update'),
]

pathotrack/urls.py
from django.contrib import admin
from django.urls import include,path
import tinymce.urls
from django.conf.urls.static import static # new
from . import settings

 

urlpatterns = [
    path('admin/', admin.site.urls),
    path('patients/', include('applications.patient_registration.urls', namespace='patients')), #every app should be added as `applications.<app name>.urls`
    path('users/', include('applications.users.urls', namespace='users')), 
    path('', include('applications.users.urls', namespace='users')), 
    path('reports/general/', include('applications.general_report.urls', namespace='general-reports')),
    path('reports/cap/', include('applications.cap_report.urls', namespace='cap-reports')),
    path('reports/consolidated/', include('applications.consolidated_report.urls', namespace='consolidated-reports')),
    path('tinymce/', include('tinymce.urls')),
]


if settings.DEBUG: # new
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

applications/general_report/models/start_diagnosis_model.py
from django.db import models
from applications.patient_registration.models.patient_registration_model import PatientRegistration


# class PathologyIDManager(models.Manager):
#     def get_queryset(self):
#         return super().get_queryset().values('pathology_id')


class ReportType(models.Model):
    value = models.CharField(max_length=200)

    def __str__(self):
        return self.value


class StartDiagnosis(models.Model):
    class Meta:
        db_table = 'diagnosis_initiation'

    STATUS = [('wip','WIP'),('draft','Draft'),('submitted','Submitted'),('approved','Approved')]
    acc_no = models.CharField('Accession number', primary_key=True, editable=False, max_length=255)
    patient_id = models.ForeignKey(PatientRegistration, verbose_name="Patient ID", editable=False, on_delete=models.CASCADE)
    patient_sample = models.CharField('Sample', max_length=255, null=True, blank=True)
    patient_ref_clinic = models.CharField('Reference clinic', max_length=255, null=True, blank=True)
    patient_ref_doctor = models.CharField('Reference doctor', max_length=255, null=True, blank=True)
    patient_external_ref = models.CharField('External reference', max_length=255, null=True, blank=True)
    patient_enter_date = models.DateTimeField('Enter date', auto_now_add=True, null=True)
    patient_exit_date = models.DateTimeField('Exit date', auto_now=True, null=True)
    report_type = models.ForeignKey(ReportType, verbose_name='Report type', on_delete=models.CASCADE)
    pathology_id = models.CharField('Pathology ID', editable=False, max_length=255, null=True)
    report_status = models.CharField('Report status', choices=STATUS, default='draft', editable=False, max_length=10)
    # date_created =
    # date_updated =
    # user_created =
    # user_updated =
    # user_verified =

    # pathologyid_manager = PathologyIDManager()

    def get_fields(self):
        return [(field.verbose_name, field.value_from_object(self)) for field in self.__class__._meta.fields]

applications/general_report/views/general_report_view.py
from django.views.generic import CreateView, UpdateView
from applications.general_report.models.general_report_model import GeneralReport, Module_name, Sub_module
from applications.general_report.models.start_diagnosis_model import StartDiagnosis
from applications.patient_registration.models.patient_registration_model import PatientRegistration
from django.shortcuts import redirect, get_object_or_404
from django.http import HttpResponse # for testing
from utils.mixins import SessionManagementMixin
import importlib



# Class to create patient entry using CreateView
class GeneralReportCreate(SessionManagementMixin, CreateView):
    model = GeneralReport
    fields = "__all__"
    template_name = "general_report_form.html"
    session_vars =  ['patient_id','acc_no','patient_name','patient_age','patient_sex']
    
    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['pathology_id'] = StartDiagnosis.objects.get(pk=self.request.session['acc_no']).pathology_id
        return context

    def get(self, request, *args, **kwargs):
        StartDiagnosis.objects.filter(pk=self.request.session['acc_no']).update(report_status="wip")
        return super().get(request, *args, **kwargs)

    def form_valid(self, form):
        submit_stat = self.request.POST.get("submit")
        acc_no = self.request.session['acc_no']
        patient_id = self.request.session['patient_id']

        if(submit_stat == "cancel"): # when "Cancel" button pressed
            StartDiagnosis.objects.filter(pk=acc_no).update(report_status="draft")
            return redirect('patients:details') # the condition where pressing cancel on filled entries has to be tested [TODO]

        form.instance.acc_no = StartDiagnosis.objects.get(pk=acc_no)
        form.instance.patient_id = PatientRegistration.objects.get(pk=patient_id)
        report = form.save()

        if(submit_stat == "save"): # when pressed "Submit & Return"
            StartDiagnosis.objects.filter(pk=acc_no).update(report_status="draft")
            return redirect('patients:details')

        if(submit_stat == "continue"): # when pressed "Submit & Continue"
            self.request.session['acc_no'] = acc_no
            self.request.session['sub_module'] = self.request.POST.get("sub_module")

            # For synoptic Reports
            if(self.request.POST.get("synoptic_stat") == "true"):

                module_id = self.request.POST.get("module_name")
                module_name = Module_name.objects.get(pk=module_id).value
                sub_module_id = self.request.POST.get("sub_module")
                sub_module = Sub_module.objects.get(pk=sub_module_id).value
                self.request.session['model_name'] = "applications.cap_report.models." + module_name.lower().replace(" ","_") + "_" + sub_module.lower().replace(" ","_") + "_model"
                self.request.session['model_class'] = module_name.replace(" ","") + sub_module.replace(" ","")
                return redirect('cap-reports:create')

            # For non-synoptic Reports
            self.request.session['model_name'] = "applications.cap_report.models.non_synoptic_model"
            self.request.session['model_class'] = "NonSynoptic"
            return redirect('cap-reports:create')

        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]


class GeneralReportUpdate(SessionManagementMixin, UpdateView):
    model = GeneralReport
    template_name = "general_report_form.html"
    fields = "__all__"
    session_vars =  ['patient_id','acc_no','patient_name','patient_age','patient_sex']

    def get_object(self):
        StartDiagnosis.objects.filter(pk=self.request.session['acc_no']).update(report_status="wip")
        return get_object_or_404(self.model, pk=self.request.session['acc_no'])

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['pathology_id'] = StartDiagnosis.objects.get(pk=self.request.session['acc_no']).pathology_id
        return context

    def model_import(self, module_name, sub_module, synoptic_stat):
        if(synoptic_stat == "true" or synoptic_stat == True):
            model_name = "applications.cap_report.models." + module_name.lower().replace(" ","_") + "_" + sub_module.lower().replace(" ","_") + "_model"
            model_class = module_name.replace(" ","") + sub_module.replace(" ","")
        else:
            model_name = "applications.cap_report.models.non_synoptic_model"
            model_class = "NonSynoptic"
        return model_name, model_class

    def form_valid(self, form):
        submit_stat = self.request.POST.get("submit")
        patient_id = self.request.session['patient_id']
        acc_no = self.request.session['acc_no']

        if(submit_stat == "cancel"):
            StartDiagnosis.objects.filter(pk=acc_no).update(report_status="draft")
            return redirect('consolidated-reports:details')

        if(submit_stat == "save"):
            StartDiagnosis.objects.filter(pk=acc_no).update(report_status="draft")
            report = form.save()
            return redirect('consolidated-reports:details')

        if(submit_stat == "continue"):
            module_name_id = self.request.POST.get("module_name")
            module_name = Module_name.objects.get(pk=module_name_id).value
            sub_module_id = self.request.POST.get("sub_module")
            sub_module = Sub_module.objects.get(pk=sub_module_id).value
            synoptic_stat = self.request.POST.get("synoptic_stat")
            model_name_str, model_class_str = self.model_import(module_name, sub_module, synoptic_stat)

            model_name = importlib.import_module(model_name_str)
            model_class = getattr(model_name, model_class_str)          
            self.request.session['model_name'] = model_name_str
            self.request.session['model_class'] = model_class_str

            if(model_class.objects.filter(pk = acc_no).exists()):
                '''if there is an entry exists for the model_class
                entry from the form input this will redirect to
                update screen'''

                report = form.save()
                return redirect('cap-reports:update')


            if (GeneralReport.objects.get(pk = acc_no).sub_module_id == None
                or GeneralReport.objects.get(pk = acc_no).synoptic_stat == None
                or GeneralReport.objects.get(pk = acc_no).module_name_id == None):
                '''if there is no value for sub_module, synoptic_stat,
                model_name previously set, this will direct to cap_report
                createview without going through the code to delete
                previous cap_report'''

                report = form.save()
                return redirect('cap-reports:create')


            if (GeneralReport.objects.get(pk = acc_no).sub_module_id != sub_module_id
                or GeneralReport.objects.get(pk = acc_no).synoptic_stat != synoptic_stat
                or GeneralReport.objects.get(pk = acc_no).module_name_id != module_name_id):
                '''to delete old cap_report'''

                gen_sub_module = GeneralReport.objects.get(pk = acc_no).sub_module.value
                gen_module_name = GeneralReport.objects.get(pk = acc_no).module_name.value
                gen_synoptic_stat = GeneralReport.objects.get(pk = acc_no).synoptic_stat
                gen_model_name, gen_model_class = self.model_import(gen_module_name, gen_sub_module, gen_synoptic_stat)
                gen_model_name = importlib.import_module(gen_model_name)
                gen_model_class = getattr(gen_model_name, gen_model_class)

                if(gen_model_class.objects.filter(pk = acc_no).exists()):
                    gen_model_class.objects.get(pk = acc_no).delete()


            report = form.save()
            return redirect('cap-reports:create')

        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]

applications/general_report/views/start_diagnosis_view.py
from django.views.generic import CreateView, UpdateView
from applications.general_report.models.start_diagnosis_model import StartDiagnosis, ReportType
from applications.patient_registration.models.patient_registration_model import PatientRegistration
from django.shortcuts import redirect, get_object_or_404
from django.http import HttpResponse # for testing
from datetime import datetime
from django.contrib import messages
from uuid import uuid4
from utils.mixins import SessionManagementMixin


class StartDiagnosisCreate(SessionManagementMixin, CreateView):
    model = StartDiagnosis
    fields = "__all__"
    template_name = "start_diagnosis_form.html"
    session_vars =  ['patient_id','acc_no','patient_name','patient_age','patient_sex']


    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['pathology_id_part'] = datetime.now().strftime("%d%m%y")+"/"+str(self.model.objects.filter(patient_enter_date__gte=datetime.today().date()).count()+1)
        return context



    def form_valid(self, form):
        submit_stat = self.request.POST.get("submit")
        report_type = self.request.POST.get("report_type")
        pathology_temp_id = self.request.POST.get("pathology_id")
        report_type_str = ReportType.objects.get(id = report_type).value
        pathology_id_str = datetime.now().strftime("%d%m%y")+"/"+str(self.model.objects.filter(patient_enter_date__gte=datetime.today().date()).count()+1)

        if(submit_stat == "cancel"): # when "Cancel" button pressed
            return redirect('patients:details')

        acc_no = str(uuid4())
        form.instance.acc_no = acc_no
        form.instance.patient_id = PatientRegistration.objects.get(pk=self.request.session['patient_id'])

        # last_id = StartDiagnosis.objects.last()
        # pathology_id = datetime.now().strftime("%y") + str(StartDiagnosis.objects.last() + 1)
        #context['pathology_id_part'] = datetime.now().strftime("%y%m%d")+"/"+str(model.objects.filter(patient_enter_date__gte=datetime.today().date()).count()+1)
#        pathology_id = datetime.now().strftime("%y%m%d%H%M%S")
        pathology_id = report_type_str[:1]+"-"+pathology_id_str

        if pathology_temp_id != pathology_id:
            messages.error(self.request, 'Pathology ID mismatch, please try again!')
            return redirect('general-reports:start-diagnosis')

        form.instance.pathology_id = pathology_id
        report = form.save()

        if(submit_stat == "save"): # when pressed "Submit & Return"
            return redirect('patients:details')

        if(submit_stat == "continue"): # when pressed "Submit & Continue"
            self.request.session['acc_no'] = acc_no # passing acc_no to general report
            return redirect('general-reports:create')

        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]

class StartDiagnosisUpdate(UpdateView):
    model = StartDiagnosis
    fields = "__all__"
    template_name = "start_diagnosis_form.html"
    session_vars =  ['patient_id','acc_no','patient_name','patient_age','patient_sex']

    def get_object(self):
        return get_object_or_404(self.model, pk=self.request.session['acc_no'])

    def form_valid(self, form):
        StartDiagnosis.objects.filter(pk=self.request.session['acc_no']).update(report_status="draft")
        submit_stat = self.request.POST.get("submit")

        if(submit_stat == "cancel"):
            return redirect('consolidated-reports:details')

        report = form.save()
        if(submit_stat == "save"):
            return redirect('consolidated-reports:details')

        if(submit_stat == "continue"):
            return redirect('consolidated-reports:details') # Should be changed to redirect to update screen or create screen of general-reports [FIX_ME]

        return HttpResponseForbidden() # improve this later by adding invalid request template[FIX_ME]

applications/general_report/templates/general_report_form.html
{% extends 'pathotrack/layout/base.html' %}
{% load widget_tweaks %}

{% block content %}

<div class="row">
  <div class="col-12">
    <form method="post" class="card">
      {% csrf_token %}

      <div class="card-header">
        <h4 class="card-title">Pathology Report</h4>
        <span class="badge bg-purple ml-2 px-2">
          {{ request.session.patient_name }}
          <span class="badge-addon">{{ request.session.patient_age }} / {{ request.session.patient_sex }}</span>
        </span>
          <span class="badge bg-blue ml-2 px-2">
          <span class="badge-single">{{ pathology_id }}</span>
        </span>
      </div>

      <div class="card-body">
        <div class="row">
          {% for field in form %}
          {% if field.label != 'Module name' and field.label != 'Sub module' and field.label != 'Synoptic report' %}
          <div class="form-group col-12 mb-3">
            {{ field.label }}
            {{ field|attr:"class:form-control mt-1"|attr:"rows:2" }}
            </div>
          {% else %}
          <div class="form-group col-md-4 mb-3">
            {{ field.label }}
            {{ field|add_class:"form-select mt-1" }}
          </div>
          {% endif %}
          {% endfor %}
        </div>
      </div>

      <div class="card-footer text-right">
        <div class="d-flex">
          <button class="btn btn-secondary m-1" type="submit" name="submit" value="cancel">Cancel</button>
          <button class="btn btn-info m-1 ml-auto" type="submit" name="submit" value="save">Save & Return</button>
          <button class="btn btn-primary m-1" type="submit" name="submit" value="continue">Submit & Continue</button>
        </div>
      </div>
    </form>
  </div>
</div>
{% endblock content %}

applications/general_report/templates/start_diagnosis_form.html
{% extends 'pathotrack/layout/base.html' %}
{% load widget_tweaks %}

{% block content %}

<div class="row">
  <div class="col-12">
    <form method="post" class="card">
      {% csrf_token %}

      <div class="card-header">
        <h4 class="card-title">Pathology Report</h4>
        <span class="badge bg-purple ml-2 px-2">
          {{ request.session.patient_name }}
          <span class="badge-addon">{{ request.session.patient_age }} / {{ request.session.patient_sex }}</span>
        </span>
      </div>

      <div class="card-body">
        <div class="row">
          {% for field in form %}
          <div class="form-group col-md-4 mb-3">
            {{ field.label }}
            {% if field|field_type == "typedchoicefield" or field|field_type == "modelchoicefield" %}
            {{ field|add_class:"form-select mt-1" }}
            {% else %}
            {{ field|add_class:"form-control mt-1" }}
            {% endif %}
          </div>
          {% endfor %}
        </div>
        <input type="hidden" name="pathology_id" id="pathology_id" value="" >
        <div id="pathology_id_alert" class="alert alert-dismissible" style="display:none" role="alert">
        </div>
      </div>

      <div class="card-footer text-right">
        <div class="d-flex">
          <a href="{% url 'patients:details' %}" class="btn btn-secondary m-1" type="submit" name="submit" value="cancel">Back</a>
          <button class="btn btn-info m-1 ml-auto" type="submit" name="submit" value="save">Save & Return</button>
          <button class="btn btn-primary m-1" type="submit" name="submit" value="continue">Submit & Continue</button>
        </div>
      </div>
    </form>
  </div>
</div>
<script>
 var pathology_id_part = "{{ pathology_id_part }}"
 $("#id_report_type").on("change", function() {
     var report_type = $(this).find(':selected').text()[0];
     var pathology_id = report_type + "-" + pathology_id_part
     $('#pathology_id_alert').show();
     $('#pathology_id_alert').empty();
     $('#pathology_id_alert').append('Pathology ID:  <b>'+pathology_id+'</b><a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>');
     $('#pathology_id_alert').addClass('alert-info');
     $('#pathology_id').val(pathology_id);

 });
</script>
{% endblock content %}